"""
compatibility replacement for our needs among the old crypt module
that was removed in 3.13 (failed to see the earlier warnings...)

were only using the crypt.crypt() function
plus, we only use MD5 for hashing, and we always provide our salt
so we only need to replace that
"""

import time
import hashlib
from random import Random

# our needs are very limited:
# we always use md5
# for creating a password hash, we always provide a salt

def plc_crypt(password: str, salt: str) -> str:

    hash_func = hashlib.md5
    hashed = hash_func((salt + password).encode()).hexdigest()

    # print(f"mycrypt {salt=} {hashed=}")

    # Format the output to mimic crypt.crypt output
    return f"{salt}{hashed}"


def test():
    def _unit_test(plaintext, crypt_function, message):
    #   creating the password (from Persons.py):
        magic = "$1$"
        salt = str(time.time()) + str(Random().random())
        salt = hashlib.md5(salt.encode()).hexdigest()[:8]
        # magic:3 salt:8 $:1 means the total salt is 12 characters
        # as can be seen in Auth.py
        crypted = crypt_function(plaintext, magic + salt + "$")
    # checking around (from Auth.py))
        #  crypt.crypt(plaintext, password[:12]) != password:
        against = crypt_function(plaintext, crypted[:12])
        print(f"{message} {crypted=} {against=}")
        assert crypted == against

    from crypt import crypt as python_crypt
    for plaintext in ["mypassword", "anotherpassword"]:
        _unit_test(plaintext, python_crypt, "python_crypt")
        _unit_test(plaintext, plc_crypt, "plc_crypt")

if __name__ == "__main__":
    test()
